package org.apache.bcel.verifier.statics;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.DescendingVisitor;
import org.apache.bcel.classfile.EmptyVisitor;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.verifier.statics.Pass2Verifier;

class InnerClassDetector extends EmptyVisitor {
  private boolean hasInnerClass;
  
  private final JavaClass jc;
  
  private final ConstantPool cp;
  
  public InnerClassDetector(JavaClass javaClass) {
    this.jc = javaClass;
    this.cp = this.jc.getConstantPool();
    (new DescendingVisitor(this.jc, this)).visit();
  }
  
  public boolean innerClassReferenced() {
    return this.hasInnerClass;
  }
  
  public void visitConstantClass(ConstantClass obj) {
    Constant c = this.cp.getConstant(obj.getNameIndex());
    String className = ((ConstantUtf8)c).getBytes();
    if (c instanceof ConstantUtf8 && className.startsWith(this.jc.getClassName().replace('.', '/') + "$"))
      this.hasInnerClass = true; 
  }
}
